#include "IMConfig.h"

void printHelp();
void printHelp2();

int main (int argc, char* argv[]) {
	IMConfig Daemon;
    if (argc == 3 && (strcmp(argv[1],"-d") == 0 || strcmp(argv[1],"-direct") == 0))
    {
 		printHelp2();
    }
    else if (argc > 3 && (strcmp(argv[1],"-d") == 0 || strcmp(argv[1],"-direct") == 0))
    {
		Daemon.setSerIP(argv[2]);
		char direct[300];
		int pos = 0, n = 3;
		while (n < argc)
		{
			strcpy(direct + pos, argv[n]);
			pos = strlen(direct);
			n++;

			if (n < argc)
			{
				strcpy(direct + pos, " ");
				pos = strlen(direct);
			}
		}
// printf("DStr: %s-\n", direct);
		Daemon.sendDirect(direct);
		printf("OK\n");
        
    } else if (argc == 3 ) {
		if (strcmp(argv[1],"-r") == 0 || strcmp(argv[1],"-reg") == 0) {
			//REGISTER
			Daemon.setSerIP(argv[2]);
			Daemon.sendRegister();
			printf("OK\n");
		} else if (strcmp(argv[1],"-i") == 0 || strcmp(argv[1],"-info") == 0) {
			//INFO
			Daemon.setSerIP(argv[2]);
			Daemon.sendInfo();
			printf("OK\n");
		} else if (strcmp(argv[1],"-reset") == 0) {
			//INFO
			Daemon.setSerIP(argv[2]);
			Daemon.sendReset();
			printf("OK\n");
		} else {
			printf ("Error in %s\n", argv[1]);
			printHelp();
		}
	} else if (argc == 4) {
		if (strcmp(argv[1],"-s") ==0 || strcmp(argv[1],"-setip") == 0) {
			//SetIP
			Daemon.setSerIP(argv[3]);
			Daemon.sendSetIP(argv[2]);
			printf("OK\n");
		} else if (strcmp(argv[1],"-f") == 0 || strcmp(argv[1],"-file") == 0) {
			//Send file
			if (Daemon.bindSocket() == 0) {
				Daemon.setSerIP(argv[3]);
				Daemon.sendFile(argv[2]);
				printf("OK\n");
			} else {
				printf("If IMDaemon is running - stop it!\n");
			}
		} else {
			printf ("Error in %s\n", argv[1]);
			printHelp();
		}
	} else if (argc == 5) {
		if (strcmp(argv[1],"-l") == 0 || strcmp(argv[1],"-license") == 0) {
			char str[200];
			memcpy(str,argv[2],strlen(argv[2])+1);
			memcpy(str+strlen(argv[2])," ",1);
			memcpy(str+strlen(argv[2])+1,argv[3],strlen(argv[3])+1);
			printf("argv2: %s, argv3: %s, str: %s\n",argv[2], argv[3], str);
                        Daemon.setSerIP(argv[4]);
                        Daemon.sendLicense(str);
                        printf("OK\n");
		} else {
                        printf ("Error in %s\n", argv[1]);
                        printHelp();
		}
	} else {
		printHelp();
	}
}

void printHelp() {
	printf("Usage: IMConsole [-r | -reg] [-i | -info] [-reset] [-s <NewIP> | -setip <NewIP>] [-d | -direct] IP [directcommand]\n");

	printf("-r \t\tSend \"REGISTER\" command to card.\n");
	printf("\t\tThe TDMoE traffic will redirected to current machine. (To the mac-addres from whitch this command sended).\n");

	printf("-i \t\tSend \"INFO\" command to card.\n");
	printf("\t\tThe information will be redirected to current machine. To IP from whitch this command is sended.\n");
	printf("\t\tThe information can be received with IMDaemon.\n");

	printf("-reset \t\tSend \"RESET\" command to card.\n");
	printf("\t\tThe card will be rebootred.\n");

	printf("-s <NewIP> \tSend \"SETIP <NewIP>\" command to card.\n");
    printf("\t\tThis will change IP-address of card to NewIP.\n");
    printf("\t\tOldIP may be broadcast type: x.x.x.255.\n");

	printf("-f <File> \tSend new firmware to card.\n");
	printf("\t\tThis will change Firmware on the card.\n");

    printf("-l <license_code_1> <license_code_2>\tSend new license.\n");
	printf("\t\tStop daemon if it is running.\n");

    printf("-d IP <command>\tSend direct command (for E1 modem only).\n");
	printf("\t\tSee direct command list by -d help\n");

	printf("IP \t\tDestination IP of packet.\n");
	printf("\t\tIf you don't know IP of card you can speccify broadcast address.\n");

	printf("\n");
}

void printHelp2() {
    printf("Usage: IMConsole -d IP <command>, where command:\n");

    printf("INFO - get version\n");
    printf("SHOW - get ip settings\n");
    printf("STATE - get PCM status\n");
    printf("RESET - reset module\n");
    printf("SETIP <ip> - set new <ip> address\n");
    printf("SETLICENSE <n1> <n2> - set license code\n");
    printf("SET JITTER PARAM <n1> <n2> <n3> - set jitter param: adaptive period ms, minimum jitter ms, possible late times\n");
    printf("SET DESTINATION <pcm> <ip> <port> - set IP:PORT destination for Link <pcm>, where <port> from 20000 to 20003\n");
    printf("SET GATE <ip_gate> <ip_mask> - set tcp/ip gate and mask\n");
    printf("ERCLEAR - clear errors\n");
    printf("ERSHOW - show errors\n");

    printf("\n");
}
